﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BladhusInterfaceLibrary;
using System.Runtime.Serialization;

namespace BladhusClassLibrary
{
    [DataContract(IsReference = true)]
    class Blad : IBlad
    {
        internal Blad(string navn, string udgivelsesfrekvens)         // constructor
        {
            this.BladNavn = navn;
            this.Udgivelsesfrekvens = udgivelsesfrekvens;
        }

        #region selve kundens data og metoder fra domain beskrivelsen

        [DataMember]
        public string BladNavn { get; private set; }
        [DataMember]
        public string Udgivelsesfrekvens { get; private set; }

        public void RetStamdata(string navn, string udgivelsesfrekvens)
        {
            this.BladNavn = navn;
            this.Udgivelsesfrekvens = udgivelsesfrekvens;
        }

        public override string ToString()
        {
            return ""+this.BladNavn+"; "+this.Udgivelsesfrekvens;
        }

        #endregion

        #region data og metoder for bladets abonnementer

        [DataMember]
        private List<IAbonnement> bladetsAbonnementer = new List<IAbonnement>();

        internal void AssocierAbonnement(IAbonnement valgtAbonnement)
        {
           this.bladetsAbonnementer.Add(valgtAbonnement);
        }

        public List<IAbonnement> FindAlleBladetsAbonnementer()
        {
            return new List<IAbonnement>(this.bladetsAbonnementer);     // returner en kopi - ny liste ud fra bladets
        }

        public List<IKunde> FindAlleBladetsKunder()
        {
            throw new NotImplementedException();
        }
        #endregion

    }
}
