﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BladhusInterfaceLibrary;
using System.Runtime.Serialization;
using System.IO;

namespace BladhusClassLibrary
{
    public static class GlobaleData         // fungerer også som facade controler (og session)
    {

        // globale "Session" data
        public static IBlad UdvalgtBlad;
        public static IKunde UdvalgtKunde;
        public static List<IBlad> UdvalgtBladliste;
        public static List<IKunde> UdvalgtKundeliste;



        // Adgang til Modellen / Kernen
        private static IBladhus _bladhuset;
        public static IBladhus Bladhuset { 
            get
            {
                if (_bladhuset == null)
                    _bladhuset = new Bladhus();
                return _bladhuset;
            } 
        }
        public static bool IsBladhusetReady
        {
            get
            {
                if (_bladhuset == null)
                    return false;
                else
                    return true;
            }
        }

        public static void SaveBladhus(string filename = "Bladhus.xml")
        {
            FileStream outStream = new FileStream(filename, FileMode.Create);
            List<Type> typeListe = new List<Type>();            // Når der anvendes interfaces bliverman desværre nødt 
                                                                // til at registrere klasser der "mødes" ved serialiseringen
            typeListe.Add(typeof(Blad));                    
            typeListe.Add(typeof(Kunde));
            typeListe.Add(typeof(Abonnement));
            typeListe.Add(typeof(BladKartotek));
            typeListe.Add(typeof(KundeKartotek));
            DataContractSerializer serializer = new DataContractSerializer(Bladhuset.GetType(), typeListe);
            serializer.WriteObject(outStream, Bladhuset as Bladhus);
            outStream.Close();
        }

        public static void LoadBladhus(string filename = "Bladhus.xml") // pas på::::
        {
            FileStream inStream = new FileStream(filename, FileMode.Open);
            List<Type> typeListe = new List<Type>();            // Når der anvendes interfaces bliverman desværre nødt 
                                                                // til at registrere klasser der "mødes" ved serialiseringen
            typeListe.Add(typeof(Blad));
            typeListe.Add(typeof(Kunde));
            typeListe.Add(typeof(Abonnement));
            typeListe.Add(typeof(BladKartotek));
            typeListe.Add(typeof(KundeKartotek));

            DataContractSerializer serializer = new DataContractSerializer(Bladhuset.GetType(), typeListe);
            //DataContractSerializer serializer = new DataContractSerializer(Bladhuset.GetType());
            _bladhuset = serializer.ReadObject(inStream) as Bladhus;
            inStream.Close();
        }


        // lidt ekstra der er pladseret her af nemhedshensyn

        public static void OpretTestBladhus()
        {
            if (_bladhuset == null)
            {
                _bladhuset = new Bladhus();
                IBladKartotek bk = _bladhuset.Bladkartoteket;
                IBlad b1 = bk.OpretBlad("C# med Bjørk", "1 gang om dagen");
                IBlad b2 = bk.OpretBlad("Test med Bjørk", "1 gang om ugen");
                IBlad b3 = bk.OpretBlad("Android med Bjørk", "1 gang om ugen");
                IBlad b4 = bk.OpretBlad("Windows Phone med Bjørk", "1 gang hver 14. dag");

                IKundeKartotek kk = _bladhuset.Kundekartoteket;
                IKunde k1 = kk.OpretKunde(1, "Ole", "Ejlskovsgade 3 indgang A", "5000", "Odense C", "ole@mail.dk");
                IKunde k2 = kk.OpretKunde(2, "Eva", "Ejlskovsgade 3 indgang B", "5000", "Odense C", "eva@mail.dk");
                IKunde k3 = kk.OpretKunde(3, "Bo", "Ejlskovsgade 3 indgang C", "5000", "Odense C", "bo@mail.dk");
                IKunde k4 = kk.OpretKunde(4, "Lis", "Ejlskovsgade 3 indgang D", "5000", "Odense C", "lis@mail.dk");

                k1.OpretAbonnement("Giro", 0, b2);

                k2.OpretAbonnement("Giro", 0, b1);
                k2.OpretAbonnement("Bank", 0, b2);
                k2.OpretAbonnement("Giro", 0, b3);

                k3.OpretAbonnement("Giro", 0, b3);
                k3.OpretAbonnement("Giro", 0, b2);
            
            }
        }

    }
}
