﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BladhusInterfaceLibrary;
using System.Runtime.Serialization;

namespace BladhusClassLibrary
{
    [DataContract(IsReference = true)]
    class Kunde : IKunde
    {
        internal Kunde(int kundenr, string navn, string gade, string postnr, string postby, string email)
        {
            this.Kundenr = kundenr;
            this.Navn = navn;
            this.Gade = gade;
            this.Postnr = postnr;
            this.Postby = postby;
            this.Email = email;
        }

         public override string ToString()
        {
            return "" + this.Navn + "; " + this.Gade + "; " + this.Postnr + "; " + this.Postby + "; " + this.Email;
        }

        #region selve kundens data og metoder fra domain beskrivelsen

        [DataMember]
        public int Kundenr { get; private set; }
        [DataMember]
        public string Navn { get; private set; }
        [DataMember]
        public string Gade { get; private set; }
        [DataMember]
        public string Postnr { get; private set; }
        [DataMember]
        public string Postby { get; private set; }
        [DataMember]
        public string Email { get; private set; }

        public void RetStamdata(string navn, string gade, string postnr, string postby, string email)
        {
            this.Navn = navn;
            this.Gade = gade;
            this.Postnr = postnr;
            this.Postby = postby;
            this.Email = email;
        }


        #endregion

        #region data og metoder for kundens abonnementer

        [DataMember]
        private List<IAbonnement> kundensAbonnementer = new List<IAbonnement>();

        public IAbonnement OpretAbonnement(string betalingsform, float rabatsats, IBlad bladet)
        {
            Abonnement nyAbonnement = new Abonnement(betalingsform,rabatsats,bladet, this);
            this.kundensAbonnementer.Add(nyAbonnement);
            return nyAbonnement;
        }

        public List<IAbonnement> FindAlleKundesAbonnementer()
        {
            return new List<IAbonnement>(this.kundensAbonnementer);     // returner en kopi - ny liste ud fra kundens
        }

        public List<IAbonnement> FindKundesAbonnementPaaBlad(IBlad valgtBlad)
        {
            throw new NotImplementedException();
        }

        public List<IBlad> FindAlleKundesBlade()
        {
            throw new NotImplementedException();
        }

        #endregion

    }
}
