﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using BladhusClassLibrary;
using BladhusInterfaceLibrary;

namespace Bladhus_WebApplication
{
    public partial class WebFormKundeOversigt : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (GlobaleData.UdvalgtKundeliste == null)
                Server.Transfer("WebFormFindKunder.aspx");
            if (IsPostBack) return;
            FyldKundeListbox();
        }

        private void FyldKundeListbox()
        {
            LbxKunder.Items.Clear();
            foreach (IKunde enKunde in GlobaleData.UdvalgtKundeliste)
            {
                LbxKunder.Items.Add(enKunde.ToString());
            }
        }

        protected void BtnKundedetail_Click(object sender, EventArgs e)
        {
            if (LbxKunder.SelectedIndex >= 0)
            {
                GlobaleData.UdvalgtKunde = GlobaleData.UdvalgtKundeliste[LbxKunder.SelectedIndex];
                Response.Redirect("WebFormKundedetail.aspx");
            }
        }

        protected void BtnOpretKunde_Click(object sender, EventArgs e)
        {
            GlobaleData.UdvalgtKunde = null;
            Response.Redirect("WebFormOpretKunde.aspx");
        }
    }
}